//+------------------------------------------------------------------+
//|                                                  MultiTrade.mq4  |
//|                                   Copyright  2008, SLP Trading. |
//|                                       http://shop.profxtools.com |
//+------------------------------------------------------------------+

#property copyright " 2008, SLP Trading Group"
#property link      "http://shop.profxtools.com" 

#define OP_CLOSEBY   96
#define OP_MODIFY    97
#define OP_CLOSE     98
#define OP_NONE      99

extern string _tmp1_ = " --- Trade params ---";
extern bool Acc5Digits = false;
extern double Lots = 1; 
extern int LotsPercent = 40; 
extern int GMT = 0; 
int StartSession1 = 0;
int EndSession1 = 1;
int StartSession2 = 22;
int EndSession2 = 24;
int ChannelBars = 18;

int    Periods[] = {PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1};
int    MinProfits[] = {36, 36, 66, 100};
int    StopLosses[] = {71, 69, 100, 90};
int    TakeProfits[] = {88, 56, 20, 39};
int    LotsPercents[] = {25, 25, 25,25};
int    ChannelsBars[] = {48, 16, 10, 10};
int    MagicNumbers[] = {2509201,  2509202, 2509203, 2509204} ;

int    NoTradeDays1[] = {0, 1, 5};
int    NoTradeDays2[] = {0, 5};

int TakeProfit = 5;
int StopLoss = 30;
int MinProfitValue = 2;
bool   TryTakeProfit = false;
bool   CheckFreezLevel = true;
int    TrailingStop = 50;

int    TradeTimeChoise = 1;
int    TradeDayOfWeek = 0;

int    SellCorrection = 0;
int    BuyCorrection = 0;
bool   CheckTimeBar = false;
bool   EqualBars = true;

bool   CheckDeleteFile = false;
int    TimeOutDeleteFile = 10;
bool   CheckSetOrder = true;
int    TimeOutSetOrder = 10;
bool   DeleteFileAfterChecking = false;
int    NumberRepeatCloseOrder = 0;

bool   ShowComment = true;
bool   ShowSettings = true;
int    TimeOutComment = 3;
bool   ShowPrint = true;
bool   ShowTime = true;
bool   ShowNameID = false;
bool   ShowMagicNumber = false;

bool   ReversTrades = false;
bool   HideIndicators = false;

int    Slippage;
int    MagicNumber;
string NameID = "MultiTrade", InitString;
double LotsForTrade;
double HBV, LBV;
color  BuyOrderColor = Blue;
color  SellOrderColor = Red;
int    LastOrderBar, LastOrderTicket, CurrentOrderTicket, CurrentOrderProfitPoint, CurrentOrderTrailingStop;
double LastOrderTime = 0;
double CurrentOrderProfit;
int    CurrentDirection = OP_NONE, LastDirection = OP_NONE, CounterRepeatClose = 0;
bool   fTime = true, StopTradesByMargin, LastisOrderSell, LastisOrderBuy, TryRepeatCloseOrder;
int    LastStartSession1, LastEndSession1, LastStartSession2, LastEndSession2;
bool   RepeatCloseOrder, FirstComment = false;
string ErrorArray[4207];

int prev_res = -1;
double MyPoint = 0.0;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   Comment("");
   CorrectSessionTimes();
   InitErrorArray();
   if (HideIndicators) HideTestIndicators(true);
   LastOrderTime=Time[0];
   LastStartSession1=StartSession1; LastEndSession1=EndSession1; LastStartSession2=StartSession2; LastEndSession2=EndSession2;
   InitString = " Trade time " + StartSession1 + ".00  " + EndSession1 + "..00 and " + StartSession2 + ".00 " + EndSession2 + ".00" + "\n";
   Comments("Initial");
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  
  MyPoint = MarketInfo(Symbol(), MODE_POINT); 
  if (Acc5Digits)
  {
    MyPoint *= 10;
  }
  
//
  for(int index = 0; index < ArraySize(Periods); index++)
  {
   MagicNumber = MagicNumbers[index];
//   if (IsMagicOrderExists(MagicNumber)) return(0);
   if (!StartRulls(index)) return(0);
   
   if (!PrepareIndicators(index)) return;

   if (isOrderSell() && !TimeCurrentBar())
      {
      if (isGroDtoBuy() || isMinProfittoClose() || TryToCloseAgain())
         {
         if (CurrentOrderProfitPoint<0 && TryTakeProfit) continue;//return(0);
         CloseSellOrder();
         continue;//return(0);
         }
      continue;//return(0);
      }
      else
   if (isOrderBuy() && !TimeCurrentBar())
      {
      if (isGroDtoSell() || isMinProfittoClose() || TryToCloseAgain())
         {
         if (CurrentOrderProfitPoint<0 && TryTakeProfit) continue;//return(0);
         CloseBuyOrder();
         continue;//return(0);
         }
      continue;//return(0);
      }

   if (IsMagicOrderExists(MagicNumber)) continue;//return(0);

   if (isGroDtoSell() && !TimeCurrentBar() && (isTimetoTrade(StartSession1, EndSession1) || isTimetoTrade(StartSession2, EndSession2)))
      {
         {
         SendSellOrder(StopLoss,TakeProfit);
         continue;//return(0);
         }
      } 
      else
   if (isGroDtoBuy() && !TimeCurrentBar() && (isTimetoTrade(StartSession1, EndSession1) || isTimetoTrade(StartSession2, EndSession2)))
      {
         {
         SendBuyOrder(StopLoss,TakeProfit);
         continue;//return(0);
         }
      }
  } // end for index
  return(0);
}
//-------------------------------------------------------------------------- 
//-------------------------------------------------------------------------- 
bool IsMagicOrderExists(int num) { 
   int TotalOrd, TekOrd;
   TotalOrd = OrdersTotal();
   for(TekOrd = 0; TekOrd < TotalOrd; TekOrd++) {
     OrderSelect(TekOrd, SELECT_BY_POS, MODE_TRADES);
     if (OrderMagicNumber()==num && OrderSymbol()==Symbol()) return(true); 
   }
   return(false);
}  
//-------------------------------------------------------------------------- 
bool TimeCurrentBar(){
   bool result=false;
   if (CheckTimeBar && Time[0]==LastOrderTime) result=true;
   return(result);
}
//-------------------------------------------------------------------------- 
bool isOrderSell(){
   bool result=false;
   int cnt=0, ticket, total;
   total=OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
         {
         if (OrderMagicNumber()!=MagicNumber) continue;
         result=true;
         CurrentOrderProfit = OrderProfit();
         CurrentOrderProfitPoint = (OrderOpenPrice()-Ask)/MyPoint;
         break;
         }
      }
   if (LastisOrderSell && !result)
      {
      if (OrderStopLoss()!=0 || OrderTakeProfit()!=0) LastOrderTime=Time[0];
      }
   LastisOrderSell=result;
   return(result);
}
//-------------------------------------------------------------------------- 
bool isOrderBuy(){
   bool result=false;
   int cnt=0, ticket, total;
   total=OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
         {
         if (OrderMagicNumber()!=MagicNumber) continue;
         result=true;
         CurrentOrderProfit = OrderProfit();
         CurrentOrderProfitPoint = (Bid-OrderOpenPrice())/MyPoint;
         break;
         }
      }
   if (LastisOrderBuy && !result)
      {
      if (OrderStopLoss()!=0 || OrderTakeProfit()!=0) LastOrderTime=Time[0];
      }
   LastisOrderBuy=result;
   return(result);
}
//-------------------------------------------------------------------------- 
bool CloseBuyOrder(){
   bool result=false;
   int cnt=0, ticket, total;
   total=OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
      {
      ticket = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
         {
         if (isFreezLevel()) continue;
         if (OrderMagicNumber()==MagicNumber)
            {
            RefreshRates();
            if (OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,BuyOrderColor))
               {
//               Comments("Buy order closed : " + OrderClosePrice());
               result=true;
               LastOrderTime=Time[0];
               LastDirection=OP_BUY;
               RepeatCloseOrder=false;
               }
            else
               {
               Comments("Error close Buy order: " + PrintError(GetLastError()));
               RepeatCloseOrder=true;
               }
            }
         }
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool CloseSellOrder(){
   bool result=false;
   int cnt=0, ticket, total;
   total=OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
      {
      ticket = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
         {
         if (isFreezLevel()) continue;
         if (OrderMagicNumber()==MagicNumber)
            {
            RefreshRates();
            if (OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,SellOrderColor))
               {
//               Comments("Sell order closed : "+OrderClosePrice());
               result=true;
               LastOrderTime=Time[0];
               LastDirection=OP_SELL;
               RepeatCloseOrder=false;
               }
            else
               {
               Comments("Error close Sell order: " + PrintError(GetLastError()));
               RepeatCloseOrder=true;
               }
            }
         }
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool TryToCloseAgain(){
   bool result=false;
   if (!RepeatCloseOrder)
      {
      CounterRepeatClose=NumberRepeatCloseOrder;
      }
   else
      {
      CounterRepeatClose=CounterRepeatClose-1;
      if (CounterRepeatClose>0)
         {
         result=true;
         }
      else
         {
         RepeatCloseOrder=false;
   //      Comments("TryToCloseAgain(): Error after repeat Close order");
         }
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool isFreezLevel()
{
   bool result=false;
   double Price, FreezLevelValue, CurrentSlippage;
   if (CheckFreezLevel)
      {
      if (OrderStopLoss()!=0 || OrderTakeProfit()!=0)
         {
         RefreshRates();
         if (OrderType()==OP_BUY) Price=Bid;
         if (OrderType()==OP_SELL) Price=Ask;
         FreezLevelValue=MarketInfo(Symbol(),MODE_FREEZELEVEL)*MyPoint;
         if (  OrderStopLoss()!=0 && FreezLevelValue>(MathAbs(Price-OrderStopLoss()  ))) result=true;
         if (OrderTakeProfit()!=0 && FreezLevelValue>(MathAbs(Price-OrderTakeProfit()))) result=true;
         }
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool SendBuyOrder(double SBO_StopLoss, double SBO_TakeProfit)
{
   //if (OrdersCountBar0(0) > 0) return(false);
   
   RefreshRates();

   int ticket=0;
   RepeatCloseOrder=false;
   if (SBO_StopLoss!=0)
      {
      if (SBO_StopLoss < MarketInfo(Symbol(),MODE_STOPLEVEL)) SBO_StopLoss = MarketInfo(Symbol(),MODE_STOPLEVEL);
      SBO_StopLoss = NormalizeDouble(Bid - SBO_StopLoss*MyPoint,MarketInfo(Symbol(),MODE_DIGITS));
      }
   if (SBO_TakeProfit!=0)
      {
      if (SBO_TakeProfit < MarketInfo(Symbol(),MODE_STOPLEVEL)) SBO_TakeProfit = MarketInfo(Symbol(),MODE_STOPLEVEL);
      SBO_TakeProfit = NormalizeDouble(Ask + SBO_TakeProfit*MyPoint,MarketInfo(Symbol(),MODE_DIGITS));
      }
   ticket=OrderSend(Symbol(),OP_BUY,LotsForTrade,Ask,Slippage,SBO_StopLoss,SBO_TakeProfit, NameID,MagicNumber,0,BuyOrderColor);
   if(ticket>0)
      {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
         {
//         Comments("Buy order opened : "+OrderOpenPrice());
         LastOrderTime=Time[0];
         LastOrderBar=Bars;
         CurrentOrderTicket=ticket;
         CurrentOrderTrailingStop=0;
         }
      }
      else 
      {
      Comments("Error open Buy order : " + PrintError(GetLastError()));
      return(false);
      }
   return(true);
}
//-------------------------------------------------------------------------- 
bool SendSellOrder(double SSO_StopLoss, double SSO_TakeProfit)
{
   //if (OrdersCountBar0(0) > 0) return(false);
   
   RefreshRates();
    
   int ticket=0;
   RepeatCloseOrder=false;
   if (SSO_StopLoss!=0)
      {
      if (SSO_StopLoss < MarketInfo(Symbol(),MODE_STOPLEVEL)) SSO_StopLoss = MarketInfo(Symbol(),MODE_STOPLEVEL);
      SSO_StopLoss = NormalizeDouble(Ask + SSO_StopLoss*MyPoint,MarketInfo(Symbol(),MODE_DIGITS));
      }
   if (SSO_TakeProfit!=0)
      {
      if (SSO_TakeProfit < MarketInfo(Symbol(),MODE_STOPLEVEL)) SSO_TakeProfit = MarketInfo(Symbol(),MODE_STOPLEVEL);
      SSO_TakeProfit = NormalizeDouble(Bid - SSO_TakeProfit*MyPoint,MarketInfo(Symbol(),MODE_DIGITS));
      }
   ticket=OrderSend(Symbol(),OP_SELL,LotsForTrade,Bid,Slippage,SSO_StopLoss,SSO_TakeProfit, NameID,MagicNumber,0,SellOrderColor);
   if(ticket>0)
      {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
         {
//         Comments("Sell order opened : "+OrderOpenPrice());
         LastOrderTime=Time[0];
         LastOrderBar=Bars;
         CurrentOrderTicket=ticket;
         CurrentOrderTrailingStop=0;
         }
      }
      else 
      {
      Comments("Error open Sell order : " + PrintError(GetLastError()));
      return(false);
      }
   return(true);
}
//-------------------------------------------------------------------------- 
bool StartRulls(int index)
{
   double LotsStep, LotsMin, LotsMax;
   int LotsDigit;

   if (!FirstComment)
      {
      FirstComment=true;
      }
   else
      {
      if (LastStartSession1!=StartSession1 || LastEndSession1!=EndSession1 || LastStartSession2!=StartSession2 || LastEndSession2!=EndSession2)
         {
         LastStartSession1=StartSession1; LastEndSession1=EndSession1; LastStartSession2=StartSession2; LastEndSession2=EndSession2;
         Comments("Another trade time EA");
         }
      }
   
   if (IsOptimization())
      {
      if (StartSession1>12) return(false);
      if (EndSession1>12) return(false);
      if (StartSession2<12) return(false);
      if (EndSession2<12) return(false);
      if (StartSession1>EndSession1 || StartSession2>EndSession2) return(false);
      }
   if(Bars<100)
     {
      Comments("StartRulls() Bars less than 100");
      return(false);  
     }
   LotsStep = NormalizeDouble(MarketInfo(Symbol(), MODE_LOTSTEP),2);
   LotsMin = NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2);
   LotsMax = NormalizeDouble(MarketInfo(Symbol(), MODE_MAXLOT),2);
   if (LotsStep==0.01) LotsDigit = 2; else LotsDigit = 1;

   //   
   if (Lots==0) 
      LotsForTrade = AccountFreeMargin()*LotsPercent/100000;
   else 
      LotsForTrade = Lots;
   
   LotsForTrade = LotsForTrade * LotsPercents[index]/100;   
   LotsForTrade = NormalizeDouble(LotsForTrade, LotsDigit);
   if (LotsForTrade > LotsMax) LotsForTrade = LotsMax;
   if (LotsForTrade < LotsMin) LotsForTrade = LotsMin;
   
   TakeProfit = TakeProfits[index];
   StopLoss = StopLosses[index];
   MinProfitValue = MinProfits[index];
   Slippage=MarketInfo(Symbol(),MODE_SPREAD);
   
/*   
   if(Slippage > 10){
     TakeProfit *= 10;
     StopLoss *= 10;
     TrailingStop *= 10;
     MinProfitValue *= 10;
   }
*/   
   return(true);
}
//-------------------------------------------------------------------------- 
bool isMinProfittoClose(){
   bool result=false;
   if (CurrentOrderProfitPoint>0 && CurrentOrderProfitPoint>=MinProfitValue && MinProfitValue!=0)
      {
      result=true;
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool isGroDtoBuy(){
   bool result=false;
   if (!ReversTrades)
      {
      if (Bid < (LBV-MyPoint*BuyCorrection) || (EqualBars && Bid <= (LBV-MyPoint*BuyCorrection))) result=true;
      }
   else
      {
      if (Bid > HBV || (EqualBars && Bid >= HBV)) result=true;
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool isGroDtoSell(){
   bool result=false;
   if (!ReversTrades)
      {
      if (Bid > (HBV+MyPoint*SellCorrection) || (EqualBars && Bid >= (HBV+MyPoint*SellCorrection))) result=true;
      }
   else
      {
      if (Bid < LBV || (EqualBars && Bid <= LBV)) result=true;
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool isTimetoTrade(int OpenHour, int CloseHour)
{
////////////////////////////// Check DayOfWeek
   int i, d_cnt, cur_d = DayOfWeek();
   if(OpenHour == StartSession1 && CloseHour == EndSession1) {
     d_cnt = ArraySize(NoTradeDays1);
     for(i = 0; i < d_cnt; i++) if(NoTradeDays1[i] == cur_d) return(false);
   } else if(OpenHour == StartSession2 && CloseHour == EndSession2) {
     d_cnt = ArraySize(NoTradeDays2);
     for(i = 0; i < d_cnt; i++) if(NoTradeDays2[i] == cur_d) return(false);
   }
////////////////////////////// Check DayOfWeek
   bool result = false;
   int CurrentHour=Hour();
   if (OpenHour > 23 || OpenHour < 0 ) OpenHour = 0;
   if (CloseHour > 23 || CloseHour < 0 ) CloseHour = 0;
   if (OpenHour<CloseHour && (Hour()>=OpenHour && Hour()<CloseHour)) result=true;
   if (OpenHour>CloseHour && (Hour()>=OpenHour || Hour()<CloseHour)) result=true;
   if (DayOfWeek()!=TradeDayOfWeek && TradeDayOfWeek!=0) result = false;
   return(result);
}
//-------------------------------------------------------------------------- 
bool Comments(string CommentString){
   bool result=false;
   int i,j;
   if (ShowPrint)
      {
      string str="";
      if (ShowTime) str=str+TimeToStr(TimeCurrent(),TIME_SECONDS)+" : ";
      if (ShowNameID) str=str+NameID;
      if (ShowMagicNumber) str=str+"("+MagicNumber+")";
      if (ShowNameID || ShowMagicNumber) str=str+": ";
      Print(str+CommentString);
      }
   if (ShowSettings)
      {
      if (ShowComment) Comment(InitString+str+CommentString);
      }
   else
      {
      if (ShowComment) Comment(str+CommentString);
      }
   return(result);
}
//-------------------------------------------------------------------------- 
//-------------------------------------------------------------------------- 
string PrintError(int ErrorCode)
{
   return(ErrorArray[ErrorCode]);
}
//-------------------------------------------------------------------------- 
void InitErrorArray()
{
   ErrorArray[0] = "No errors";
   ErrorArray[1] = "No errors, but no resulting";
   ErrorArray[2] = "General fault";
   ErrorArray[3] = "Fault parameters"; 
   ErrorArray[4] = "Trade busy"; 
   ErrorArray[5] = "Old version of terminal"; 
   ErrorArray[6] = "Not connect"; 
   ErrorArray[7] = "Rules not good for you"; 
   ErrorArray[8] = "Very many orders"; 
   ErrorArray [9] = "Invalid operation disrupt the server"; 
    ErrorArray [64] = "blocked account"; 
    ErrorArray [65] = "Invalid account number"; 
    ErrorArray [128] = "Expired expectations of the transaction"; 
    ErrorArray [129] = "Invalid price"; 
    ErrorArray [130] = "Wrong foot"; 
    ErrorArray [131] = "Invalid volume"; 
    ErrorArray [132] = "The market is closed"; 
    ErrorArray [133] = "Trade is prohibited"; 
    ErrorArray [134] = "Not enough money for the transaction"; 
    ErrorArray [135] = "Price has changed"; 
    ErrorArray [136] = "No price"; 
    ErrorArray [137] = "Broker busy"; 
    ErrorArray [138] = "New prices"; 
    ErrorArray [139] = "Order has been blocked and processed"; 
    ErrorArray [140] = "Allow only buy"; 
    ErrorArray [141] = "Too many bugs"; 
    ErrorArray [145] = "Modification is prohibited, as the warrant is too close to the market"; 
    ErrorArray [146] = "subsystem busy trade"; 
    ErrorArray [147] = "Using the date of expiry of the warrant is prohibited broker"; 
    ErrorArray [148] = "The number of open orders and deferred reached the limit set by the broker"; 
    ErrorArray [4000] = "No errors"; 
    ErrorArray [4001] = "Invalid Index function"; 
    ErrorArray [4002] = "Index array - out of range"; 
    ErrorArray [4003] = "No memory to stack functions"; 
    ErrorArray [4004] = "stack overflow after recursive call"; 
    ErrorArray [4005] = "At no memory of the stack to pass options"; 
    ErrorArray [4006] = "No memory for a string parameter"; 
    ErrorArray [4007] = "No memory for a temporary line"; 
    ErrorArray [4008] = "Neinitsializirovannaya line"; 
    ErrorArray [4009] = "Neinitsializirovannaya line in the array"; 
    ErrorArray [4010] = "No memory for an array string"; 
    ErrorArray [4011] = "Too long line"; 
    ErrorArray [4012] = "Balance of dividing by zero"; 
    ErrorArray [4013] = "The division by zero"; 
    ErrorArray [4014] = "Unknown command"; 
    ErrorArray [4015] = "Invalid conversion"; 
    ErrorArray [4016] = "Neinitsializirovanny array"; 
    ErrorArray [4017] = "Challenge DLL not allowed "; 
    ErrorArray [4018] = "Can not load library"; 
    ErrorArray [4019] = "Can not call"; 
    ErrorArray [4020] = "Challenge external library functions are not allowed "; 
    ErrorArray [4021] = "Not enough memory to the line, recovery of the function"; 
    ErrorArray [4022] = "system busy"; 
    ErrorArray [4050] = "Wrong number of parameters function"; 
    ErrorArray [4051] = "Invalid value functions"; 
    ErrorArray [4052] = "Internal error string functions"; 
    ErrorArray [4053] = "Error array"; 
    ErrorArray [4054] = "Misuse of solid-taymserii"; 
    ErrorArray [4055] = "user error indicator"; 
    ErrorArray [4056] = "Arrays incompatible"; 
    ErrorArray [4057] = "Error processing globalnyeh variables"; 
    ErrorArray [4058] = "global variable is not detected"; 
    ErrorArray [4059] = "function is not allowed in test mode"; 
    ErrorArray [4060] = "function is not allowed"; 
    ErrorArray [4061] = "Error sending"; 
    ErrorArray [4062] = "expected parameter type string"; 
    ErrorArray [4063] = "expected parameter type integer"; 
    ErrorArray [4064] = "expected parameter type double"; 
    ErrorArray [4065] = "As expected array parameter"; 
    ErrorArray [4066] = "The requested historical data in a state of renewal"; 
    ErrorArray [4067] = "Error executing trading operations"; 
    ErrorArray [4099] = "End file"; 
    ErrorArray [4100] = "error when working with the file"; 
    ErrorArray [4101] = "Invalid file name"; 
    ErrorArray [4102] = "Too many open files"; 
    ErrorArray [4103] = "Can not open file"; 
    ErrorArray [4104] = "Incompatible regime access to the file"; 
    ErrorArray [4105] = "No warrant is not selected"; 
    ErrorArray [4106] = "Unknown symbol"; 
    ErrorArray [4107] = "Invalid setting prices for commercial functions"; 
    ErrorArray [4108] = "Wrong number tiketa"; 
    ErrorArray [4109] = "Trade is not allowed. You need to include the option Allow an adviser to trade in the properties of expert"; 
    ErrorArray [4110] = "Long positions are not allowed. You should check the properties of expert"; 
    ErrorArray [4111] = "Short positions are not allowed. You should check the properties of expert"; 
    ErrorArray [4200] = "Object already exists"; 
    ErrorArray [4201] = "Requested an unknown object property"; 
    ErrorArray [4202] = "The object does not exist"; 
    ErrorArray [4203] = "Unknown type of object"; 
    ErrorArray [4204] = "No, the object name "; 
    ErrorArray [4205] = "Error coordinates object"; 
    ErrorArray [4206] = "said subwindow Not Found"; 
    ErrorArray [4207] = "error when working with the object";
}
//-------------------------------------------------------------------------- 
// 
bool PrepareIndicators(int index)
   {
      HBV = iHigh(NULL, Periods[index], iHighest(NULL, Periods[index], MODE_HIGH, ChannelsBars[index], 1));
      LBV = iLow(NULL, Periods[index], iLowest(NULL, Periods[index], MODE_LOW , ChannelsBars[index], 1));
      return (true);
   }
//-------------------------------------------------------------------------- 
//-------------------------------------------------------------------------- 
int CorrectGMTime(int tim)
{
  int res = tim + GMT;
  if(res > 24) res = res - 24;
  else if(res < 0) res = 24 + res;
  else if(res == 24) res = 0;
  return(res);
}
//-------------------------------------------------------------------------- 
void CorrectSessionTimes()
{
  int tim1 = CorrectGMTime(EndSession1);
  int tim2 = CorrectGMTime(StartSession2);
  
  if(tim1 != 0 && tim2 != 0){
    if(tim2 > tim1){
      EndSession1 = tim1;
      StartSession2 = tim2;
    }else{
      EndSession1 = tim2;
      StartSession2 = tim1;
    }
  }else{
    if(tim1 != 0) EndSession1 = tim1;
    else EndSession1 = tim2;
    StartSession2 = 24;
  }
}
//--------------------------------------------------------------------------

/*
int OrdersCountBar0(int TF)
{
  int orders = 0;

  int cnt = OrdersTotal();
  for (int i=0; i<cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    //if (OrderMagicNumber() != MagicNumber) continue;

    if (OrderOpenTime() >= iTime(NULL, TF, 0)) orders++;
  }

  cnt = OrdersHistoryTotal();
  for (i=0; i<cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
    if (OrderSymbol() != Symbol()) continue;
    //if (OrderMagicNumber() != MagicNumber) continue;

    if (OrderOpenTime() >= iTime(NULL, TF, 0)) orders++;
  }
 
  return (orders);
}
*/

/*
string TF2Str(int period) 
{
  switch (period) 
  {
    case PERIOD_M1: return("M1");
    case PERIOD_M5: return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1: return("H1");
    case PERIOD_H4: return("H4");
    case PERIOD_D1: return("D1");
    case PERIOD_W1: return("W1");
    case PERIOD_MN1: return("MN");
 }
 
  return (period);
}
*/



